%VG11 uloha 1.1b (afinni transformace)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky

%29 L
%46 K

%=================================================================+
vg11_1_1_50 %nazev souboru s puvodnimi souradnicemi a polomerem   |
            %(zmenit cislo na konci podle individualniho zadani)  |
%=================================================================+

fid = fopen('1.1b.txt','w'); %vytvoreni *.txt souboru pro vystup

ss = ss_crd;
r = radius;



fprintf(fid,'VG11 - uloha 1.1b\n');
fprintf(fid,'-----------------\n\n');

%souradnice
y = 3;
x = 2;

Y = 5;
X = 4;

%body
A = 1;
B = 2;
H = 8;
I = 9;

ro = 200/pi;

% kostra vysledneho pravidelneho obrazce
hold on;
axis equal;
delta = (abs(ss(B,X) - ss(A,X)))/10;
axis([ss(A,X)-delta ss(B,X)+delta ss(A,Y)-delta ss(H,Y)+delta]);
title('Afinn transformace','FontWeight','bold','FontSize',12,'FontAngle','italic','VerticalAlignment','bottom');
whitebg('white');



plot([ss(H,X),ss(A,X),ss(B,X),ss(I,X),ss(H,X),ss(B,X)],[ss(H,Y),ss(A,Y),ss(B,Y),ss(I,Y),ss(H,Y),ss(B,Y)],'r') %vysledny ctyruhelnik

text(ss(A,X),ss(A,Y),'A ','FontWeight','bold','HorizontalAlignment','right','VerticalAlignment','top'); %popis rohu
text(ss(B,X),ss(B,Y),' B','FontWeight','bold','VerticalAlignment','top');
text(ss(H,X),ss(H,Y),'H  ','FontWeight','bold','HorizontalAlignment','right','VerticalAlignment','bottom');
text(ss(I,X),ss(I,Y),' I','FontWeight','bold','VerticalAlignment','bottom');

xlabel('                                                                               x [m]');
ylabel('                                                                               y [m]');


%============================================================================

%primka     y = k*x + q

ax = ss(H,x); %x-ova souradnice bodu A
ay = ss(H,y); %y-ova souradnice bodu A

bx = ss(B,x); %x-ova souradnice bodu B
by = ss(B,y); %y-ova souradnice bodu B

k = (ay-by)/(ax-bx);

q = ay-k*ax;

q = by-k*bx;

%kruznice    (x-m)^2 + (y-n)^2 = r^2

m = ss(I,x); %x-ova souradnice stredu kruznice
n = ss(I,y); %y-ova souradnice stredu kruznice
r = r; %polomer kruznice


%prusecik primky s kruznici

%bod 2
%fprintf(fid,'        IB\n');
x2 = 1/2/(1+k^2)*(-2*k*q+2*m+2*k*n+2*(-2*k*q*m+2*m*k*n-n^2+r^2+2*q*n-q^2+k^2*r^2-k^2*m^2)^(1/2));

y2 = 1/2/(1+k^2)*(2*m*k+2*k^2*n+2*q-2*(2*m*k^3*n+2*k^2*n*q-k^2*n^2+k^2*r^2-2*k^3*q*m-k^4*m^2-k^2*q^2+k^4*r^2)^(1/2));

%bod 3
%fprintf(fid,'        IH\n');
x3 = 1/2/(1+k^2)*(-2*k*q+2*m+2*k*n-2*(-2*k*q*m+2*m*k*n-n^2+r^2+2*q*n-q^2+k^2*r^2-k^2*m^2)^(1/2));

y3 = 1/2/(1+k^2)*(2*m*k+2*k^2*n+2*q+2*(2*m*k^3*n+2*k^2*n*q-k^2*n^2+k^2*r^2-2*k^3*q*m-k^4*m^2-k^2*q^2+k^4*r^2)^(1/2));


%============================================================================
%smerniky na pruseciky kruznice s uhloprickami
s1 = atan2(ss(B,y)-ss(I,y),ss(B,x)-ss(I,x));
s2 = atan2(y2-ss(I,y),x2-ss(I,x));
if s2 > s1
   s2 = s2 - 2*pi;
end

s3 = atan2(y3-ss(I,y),x3-ss(I,x));
if s3 > s2
   s3 = s3 - 2*pi;
end

s4 = atan2(ss(H,y)-ss(I,y),ss(H,x)-ss(I,x));
if s4 > s3
   s4 = s4 - 2*pi;
end

%prusecik se stranou IB
x1 = ss(I,x) + r * cos(s1);
y1 = ss(I,y) + r * sin(s1);

%prusecik se stranou IH
x4 = ss(I,x) + r * cos(s4);
y4 = ss(I,y) + r * sin(s4);

%*****************************************************************************************

% L        H 
% |\       |\
% | \      | \
% |  \     |  \
% V---P    A---B

L = H;
V = A;
P = B;

A = [
1 0 ss(L,x) ss(L,y)    0       0
0 1    0       0    ss(L,x) ss(L,y)
1 0 ss(V,x) ss(V,y)    0       0
0 1    0       0    ss(V,x) ss(V,y)
1 0 ss(P,x) ss(P,y)    0       0
0 1    0       0    ss(P,x) ss(P,y)
];

dX = [
ss(L,X)    
ss(L,Y)    
ss(V,X)    
ss(V,Y)    
ss(P,X)    
ss(P,Y)    
];

a = inv(A) * dX;

%transformacni koeficienty
TX = a(1);
TY = a(2);
r11 = a(3);
r12 = a(4);
r21 = a(5);
r22 = a(6);

fprintf(fid,'obrazec HAB\n');
fprintf(fid,'========================================================================\n\n');
fprintf(fid,'Transformacni koeficienty\n');
fprintf(fid,'---------------------------------------\n');

fprintf(fid,' Tx = %15.10f\n',TX);
fprintf(fid,' Ty = %15.10f\n',TY);
fprintf(fid,'r11 = %15.10f\n',r11);
fprintf(fid,'r12 = %15.10f\n',r12);
fprintf(fid,'r21 = %15.10f\n',r21);
fprintf(fid,'r22 = %15.10f\n\n\n',r22);


%prusecik u bodu B
fprintf(fid,'Prusecik oblouku a uhlopricky u bodu B\n');
fprintf(fid,'--------------------------------------\n');

xt = x2;
yt = y2;

xHB_BT = xt * r11 + yt * r12 + TX;
yHB_BT = xt * r21 + yt * r22 + TY;

 fprintf(fid,'\txHB = %+.5f m\n',xHB_BT);
 fprintf(fid,'\tyHB = %+.5f m\n\n',yHB_BT);


%prusecik u bodu H
fprintf(fid,'Prusecik oblouku a uhlopricky u bodu H\n');
fprintf(fid,'--------------------------------------\n');

xt = x3;
yt = y3;

xHB_HT = xt * r11 + yt * r12 + TX;
yHB_HT = xt * r21 + yt * r22 + TY;

 fprintf(fid,'\txHB = %+.5f m\n',xHB_HT);
 fprintf(fid,'\tyHB = %+.5f m\n\n',yHB_HT);


%vykreslen - obrazec HAB


% body na T kruznici
xkT = xHB_HT;
ykT = yHB_HT;

for i=s3:pi/100:s2 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(I,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(I,y) + r * sin(i);
    
%    xk(end+1,1) = xt; %S1
%    yk(end+1,1) = yt;



    xkT(end+1,1) = xt * r11 + yt * r12 + TX; %S2
    ykT(end+1,1) = xt * r21 + yt * r22 + TY;
end

xkT(end+1,1) = xHB_BT;
ykT(end+1,1) = yHB_BT;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku


%*****************************************************************************************

% L        B 
% |\       |\
% | \      | \
% |  \     |  \
% V---P    I---H

L = B;
V = I;
P = H;

A = [
1 0 ss(L,x) ss(L,y)    0       0
0 1    0       0    ss(L,x) ss(L,y)
1 0 ss(V,x) ss(V,y)    0       0
0 1    0       0    ss(V,x) ss(V,y)
1 0 ss(P,x) ss(P,y)    0       0
0 1    0       0    ss(P,x) ss(P,y)
];

dX = [
ss(L,X)    
ss(L,Y)    
ss(V,X)    
ss(V,Y)    
ss(P,X)    
ss(P,Y)    
];

a = inv(A) * dX;

%transformacni koeficienty
TX = a(1);
TY = a(2);
r11 = a(3);
r12 = a(4);
r21 = a(5);
r22 = a(6);

fprintf(fid,'\n\n\nobrazec BIH\n');
fprintf(fid,'========================================================================\n\n');
fprintf(fid,'Transformacni koeficienty\n');
fprintf(fid,'---------------------------------------\n');

fprintf(fid,' Tx = %15.10f\n',TX);
fprintf(fid,' Ty = %15.10f\n',TY);
fprintf(fid,'r11 = %15.10f\n',r11);
fprintf(fid,'r12 = %15.10f\n',r12);
fprintf(fid,'r21 = %15.10f\n',r21);
fprintf(fid,'r22 = %15.10f\n\n\n',r22);



xt = x4;
yt = y4;

xIH_T = xt * r11 + yt * r12 + TX;
yIH_T = xt * r21 + yt * r22 + TY;

xt = x1;
yt = y1;

xIB_T = xt * r11 + yt * r12 + TX;
yIB_T = xt * r21 + yt * r22 + TY;

%----------------------------------------------------------------------
% body na T kruznici u strany IH
xkT = xIH_T;
ykT = yIH_T;

for i=s4:pi/100:s3 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(I,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(I,y) + r * sin(i);
    

    xkT(end+1,1) = xt * r11 + yt * r12 + TX; %S2
    ykT(end+1,1) = xt * r21 + yt * r22 + TY;
end

xkT(end+1,1) = xHB_HT;
ykT(end+1,1) = yHB_HT;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku u strany IH

%----------------------------------------------------------------------

% body na T kruznici u strany IH
xkT = xHB_BT;
ykT = yHB_BT;

for i=s2:pi/100:s1 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(I,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(I,y) + r * sin(i);
    

    xkT(end+1,1) = xt * r11 + yt * r12 + TX; %S2
    ykT(end+1,1) = xt * r21 + yt * r22 + TY;
end

xkT(end+1,1) = xIB_T;
ykT(end+1,1) = yIB_T;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku u strany IH

fprintf(fid,'Prusecik oblouku se stranou IB\n');
fprintf(fid,'------------------------------\n');

fprintf(fid,'\txIB = %+.5f m\n',xIB_T);
fprintf(fid,'\tyIB = %+.5f m\n\n',yIB_T);


fprintf(fid,'Prusecik oblouku a uhlopricky u bodu B\n');
fprintf(fid,'--------------------------------------\n');

fprintf(fid,'\txHB = %+.5f m\n',xHB_BT);
fprintf(fid,'\tyHB = %+.5f m\n\n',yHB_BT);


fprintf(fid,'Prusecik oblouku a uhlopricky u bodu H\n');
fprintf(fid,'--------------------------------------\n');

fprintf(fid,'\txHB = %+.5f m\n',xHB_HT);
fprintf(fid,'\tyHB = %+.5f m\n\n',yHB_HT);


fprintf(fid,'Prusecik oblouku se stranou IH\n');
fprintf(fid,'------------------------------\n');

fprintf(fid,'\txIH = %+.5f m\n',xIH_T);
fprintf(fid,'\tyIH = %+.5f m\n\n',yIH_T);


title('');
print -dpng 1.1b.png; %automaticky export do *.png
title('Afinn transformace','FontWeight','bold','FontSize',12,'FontAngle','italic','VerticalAlignment','bottom');

fclose(fid);
fprintf(fid,'Ciselne vysledky jsou ulozeny v souboru "1.1b.txt"\n v pracovnim adresari, graf jako obrazek "1.1b.png"');