%VG11 uloha 1.2 (Helmertova 3D transformace)
%RSC (rsc@email.cz)


clear %vymazani pameti
clc %smazani obrazovky


%=================================================================+
vg11_1_2_50 %nazev souboru se vstupvimi souradnicemi              |
            %(zmenit cislo na konci podle individualniho zadani)  |
%=================================================================+

fid = fopen('1.2.txt','w'); %vytvoreni *.txt souboru pro vystup

ro = 200/pi;

%ss = ss_crd;

fprintf(fid,'VG11 - uloha 1.2\n');
fprintf(fid,'-----------------\n\n');


S1 = [ss_crd(:,2) ss_crd(:,3) ss_crd(:,4)]; %S1 jako samostatna Mat

S2 = [ss_crd(:,5) ss_crd(:,6) ss_crd(:,7)]; %S2 -||-


%souradnice
x = 1;
y = 2;
z = 3;


ro = 200/pi;


%vypocet pribliznych transformacnich koeficientu
A = [
1 0 0 S1(1,x) S1(1,y) S1(1,z)    0       0       0       0       0       0
0 1 0    0       0       0    S1(1,x) S1(1,y) S1(1,z)    0       0       0
0 0 1    0       0       0       0       0       0    S1(1,x) S1(1,y) S1(1,z)
1 0 0 S1(2,x) S1(2,y) S1(2,z)    0       0       0       0       0       0
0 1 0    0       0       0    S1(2,x) S1(2,y) S1(2,z)    0       0       0
0 0 1    0       0       0       0       0       0    S1(2,x) S1(2,y) S1(2,z)
1 0 0 S1(3,x) S1(3,y) S1(3,z)    0       0       0       0       0       0
0 1 0    0       0       0    S1(3,x) S1(3,y) S1(3,z)    0       0       0
0 0 1    0       0       0       0       0       0    S1(3,x) S1(3,y) S1(3,z)
1 0 0 S1(4,x) S1(4,y) S1(4,z)    0       0       0       0       0       0
0 1 0    0       0       0    S1(4,x) S1(4,y) S1(4,z)    0       0       0
0 0 1    0       0       0       0       0       0    S1(4,x) S1(4,y) S1(4,z)
];

dX = [
S2(1,x)
S2(1,y)
S2(1,z)
S2(2,x)
S2(2,y)
S2(2,z)
S2(3,x)
S2(3,y)
S2(3,z)
S2(4,x)
S2(4,y)
S2(4,z)
];


%priblizne transformacni koeficienty
a = inv(A)*dX;

Tx0  = a(1);
Ty0  = a(2);
Tz0  = a(3);
r11 = a(4);
r12 = a(5);
r13 = a(6);
r21 = a(7);
r22 = a(8);
r23 = a(9);
r31 = a(10);
r32 = a(11);
r33 = a(12);

%priblizna zmena meritka
q0 = (((S2(1,x)-S2(2,x))^2 + (S2(1,y)-S2(2,y))^2 + (S2(1,z)-S2(2,z))^2)^0.5) / (((S1(1,x)-S1(2,x))^2 + (S1(1,y)-S1(2,y))^2 + (S1(1,z)-S1(2,z))^2)^0.5);

%priblizne stoceni
alfa0 = atan2(r23,r33);
beta0 = asin(-r13/q0);
gama0 = atan2(r12,r11);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Tx = 0;
Ty = 0;
Tz = 0;
q = 0;
alfa = 0;
beta = 0;
gama = 0;

p = 0; %pocet iteraci

SUM = Tx + Ty + Tz + q + alfa + beta + gama; %kontrolni symbol 1
SUM0 = Tx0 + Ty0 + Tz0 + q0 + alfa0 + beta0 + gama0; %kontrolni symbol 2

while SUM ~= SUM0 %cyklus WHILE   <==========================================================
    %tento cyklus iteruje transformacni koeficienty do te doby,
    %dokud nejsou dve po sobe jdouci iterace (prubehy) stejne
    %kontrola probiha pomoci symbolu SUM a SUM0
    
SUM0 = Tx0 + Ty0 + Tz0 + q0 + alfa0 + beta0 + gama0;

p = p+1;



%priblizne matice rotace
Ralfa0 = [
    1       0         0
    0  cos(alfa0) sin(alfa0)
    0 -sin(alfa0) cos(alfa0)
];

Rbeta0 = [
    cos(beta0) 0 -sin(beta0)
        0      1      0
    sin(beta0) 0  cos(beta0)
];

Rgama0 = [
     cos(gama0)  sin(gama0) 0
    -sin(gama0)  cos(gama0) 0
         0          0       1
];    

%celkova (priblizna) matice rotace
R0 = Ralfa0 * Rbeta0 * Rgama0;

%derivace matic rotace
dRa = [
     0       0            0
     0  -sin(alfa0)   cos(alfa0)
     0  -cos(alfa0)  -sin(alfa0)
];

dRb = [
     -sin(beta0) 0 -cos(beta0)
          0      0      0
      cos(beta0) 0 -sin(beta0)
];

dRg = [
     -sin(gama0)  cos(gama0) 0
     -cos(gama0) -sin(gama0) 0
          0           0      0
];


Dalfa = dRa * Rbeta0 * Rgama0;
Dbeta = Ralfa0 * dRb * Rgama0;
Dgama = Ralfa0 * Rbeta0 * dRg;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%MNC

E = eye(3); %jednotkova Mat (33)

%Mat A (Mat planu)
A = [
    E  R0 * S1(1,:)' q0*Dalfa*S1(1,:)' q0*Dbeta*S1(1,:)' q0*Dgama*S1(1,:)'
    E  R0 * S1(2,:)' q0*Dalfa*S1(2,:)' q0*Dbeta*S1(2,:)' q0*Dgama*S1(2,:)'
    E  R0 * S1(3,:)' q0*Dalfa*S1(3,:)' q0*Dbeta*S1(3,:)' q0*Dgama*S1(3,:)'
    E  R0 * S1(4,:)' q0*Dalfa*S1(4,:)' q0*Dbeta*S1(4,:)' q0*Dgama*S1(4,:)'
    E  R0 * S1(5,:)' q0*Dalfa*S1(5,:)' q0*Dbeta*S1(5,:)' q0*Dgama*S1(5,:)'
    E  R0 * S1(6,:)' q0*Dalfa*S1(6,:)' q0*Dbeta*S1(6,:)' q0*Dgama*S1(6,:)'
    E  R0 * S1(7,:)' q0*Dalfa*S1(7,:)' q0*Dbeta*S1(7,:)' q0*Dgama*S1(7,:)'
    E  R0 * S1(8,:)' q0*Dalfa*S1(8,:)' q0*Dbeta*S1(8,:)' q0*Dgama*S1(8,:)'
];

%Vec l' (redukovana mereni)

 l = [
q0 * R0 * S1(1,:)' - S2(1,:)'
q0 * R0 * S1(2,:)' - S2(2,:)'
q0 * R0 * S1(3,:)' - S2(3,:)'
q0 * R0 * S1(4,:)' - S2(4,:)'
q0 * R0 * S1(5,:)' - S2(5,:)'
q0 * R0 * S1(6,:)' - S2(6,:)'
q0 * R0 * S1(7,:)' - S2(7,:)'
q0 * R0 * S1(8,:)' - S2(8,:)'
];

%vypocet prirustku

dX = -inv(A' * A) * A' * l;

%oprava pribliznych transformacnich koeficientu
Tx0 = dX(1);
Ty0 = dX(2);
Tz0 = dX(3);
q0 = q0 + dX(4);
alfa0 = alfa0 + dX(5);
beta0 = beta0 + dX(6);
gama0 = gama0 + dX(7);
  
SUM = Tx0 + Ty0 + Tz0 + q0 + alfa0 + beta0 + gama0;


end %konec cyklu WHILE   <=========================================================

fprintf(fid,'pocet iteraci transformacnich koeficientu = %.f \n\n',p);

Tx = Tx0; %vyrovnane transformacni koeficienty
Ty = Ty0;
Tz = Tz0;
q = q0;
alfa = alfa0;
beta = beta0;
gama = gama0;

alfag = ro * alfa; %prevod uhlu rotace na grady
if alfag < 0
    alfag = alfag + 400;
end

betag = ro * beta;
if betag < 0
    betag = betag + 400;
end

gamag = ro * gama;
if gamag < 0
    gamag = gamag + 400;
end




v = A * dX + l; %vypocet oprav


%%%%%%%<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

%matice rotace
Ralfa = [
    1       0         0
    0  cos(alfa) sin(alfa)
    0 -sin(alfa) cos(alfa)
];

Rbeta = [
    cos(beta) 0 -sin(beta)
        0      1      0
    sin(beta) 0  cos(beta)
];

Rgama = [
     cos(gama)  sin(gama) 0
    -sin(gama)  cos(gama) 0
         0          0     1
];    

%celkova matice rotace
R = Ralfa * Rbeta * Rgama;


%konecna transformace (identickych) bodu
%---------------------------------------
for i=1:8
    pom = q * R * S1(i,:)' + [Tx Ty Tz]';%vypocet po jednotlivych bodech
    
    S2C(3*i-2,1) = pom(1); %ulozeni vyslednych souradnic do Vecu S2C
    S2C(3*i-1,1) = pom(2);
    S2C(3*i,1) = pom(3);
end

S2_trans_Mat = reshape(S2C,3,8)';%Matice souradnic (identickych) bodu (X Y Z)

S2B = reshape(S2',24,1); %S2 jako sloupcovy Vec

%S2C;

%druhy vypocet oprav
(S2B - S2C + v);


vM = reshape(v,8,3); %Vec oprav jako Mat


%vypocet strednich chyb

%sigmove zkousky
v1 = v'*v; %Sigma I
v2 = l'*l + l'*A*dX; %Sigma II


%aposteriorni stredni chyba jednotkova
m0 = (v1/(24-7))^0.5;

%obecne stredni chyby souradnic
mx = (sum(vM(:,1) .* vM(:,1)) / 8)^0.5;
my = (sum(vM(:,2) .* vM(:,2)) / 8)^0.5;
mz = (sum(vM(:,3) .* vM(:,3)) / 8)^0.5;
mxyz = (v'*v/24)^.5;  %((mx^2 + my^2 + mz^2)/3)^0.5
mv = (mx^2 + my^2 + mz^2)^0.5; %mira ztotoznen



%kovariancni Mat vyrovnanych transformacnich koeficientu
Qx = inv(A' * A);
Mx = m0^2 * Qx;
Mx = diag(Mx).^0.5;

Mxa = ro * Mx(5);%stredni chyby uhlu stoceni v gradech
Mxb = ro * Mx(6);
Mxc = ro * Mx(7);


%kovariancni Mat souradnic vyrovnanych ID bodu
Ql = A*(inv(A' * A))*A';
Ml = m0^2 * Ql;
Ml = diag(Ml).^0.5;

Ml_Mat = 1000 * reshape(Ml,3,8)';%Matice strednich chyb identickych bodu (mx my mz)


% ====================================  VYPIS VYSLEDK  ====================================


fprintf(fid,'\nVysledne pretransformovane souradnice identickych bodu a jejich stredni chyby\n');
fprintf(fid,'-------------------------------------------------------------------------------\n');
fprintf(fid,'bod        X [m]   mX [mm]          Y [m]   mY [mm]          Z [m]   mZ [mm]\n');
fprintf(fid,'-------------------------------------------------------------------------------\n');

for i=1:8
    fprintf(fid,'%s \t %10.3f \t %2.1f \t %10.3f \t %2.1f \t %10.3f \t %2.1f\n',ss_id(i),S2_trans_Mat(i,1),Ml_Mat(i,1),S2_trans_Mat(i,2),Ml_Mat(i,2),S2_trans_Mat(i,3),Ml_Mat(i,3));
end


fprintf(fid,'\nCharakteristiky presnosti\n');
fprintf(fid,'---------------------------\n');


fprintf(fid,'Sigmove zkousky\n');
fprintf(fid,'Sigma I  = %.11f \n',v1);
fprintf(fid,'Sigma II = %.11f \n\n',v2);

fprintf(fid,'   m0 = %3.1f mm (aposteriorn)\n\n',1000*m0);


fprintf(fid,'   mX = %3.1f mm\n',1000*mx);
fprintf(fid,'   mY = %3.1f mm\n',1000*my);
fprintf(fid,'   mZ = %3.1f mm\n',1000*mz);
fprintf(fid,' mXYZ = %3.1f mm\n',1000*mxyz);
fprintf(fid,'   mV = %3.1f mm\n\n',1000*mv);

fprintf(fid,'Vyrovnane transformacni koeficienty a jejich stredni chyby\n');
fprintf(fid,'----------------------------------------------------------\n');
fprintf(fid,'  Tx = %18.12f m  \t   mTx = %3.1f mm\n',Tx,1000*Mx(1));
fprintf(fid,'  Ty = %18.12f m  \t   mTy = %3.1f mm\n',Ty,1000*Mx(2));
fprintf(fid,'  Tz = %18.12f m  \t   mTz = %3.1f mm\n',Tz,1000*Mx(3));
fprintf(fid,'   q = %18.12f    \t    mq = %2.7f\n',q,Mx(4));
fprintf(fid,'alfa = %10.4f g \t\t malfa = %2.0f cc\n',alfag,10000*Mxa);
fprintf(fid,'beta = %10.4f g \t\t mbeta = %2.0f cc\n',betag,10000*Mxb);
fprintf(fid,'gama = %10.4f g \t\t mgama = %2.0f cc\n',gamag,10000*Mxc);

% fprintf(fid,'\n\nalfa = %18.12f rad\n',alfa);
% fprintf(fid,'beta = %18.12f rad\n',beta);
% fprintf(fid,'gama = %18.12f rad\n',gama);


fclose(fid);
fprintf(1,'\n\nCiselne vysledky jsou ulozeny v souboru "1.2.txt"\n v pracovnim adresari\n\n');